diff --git i/src/backend/libpq/auth.c w/src/backend/libpq/auth.c
index 7799111..3701672 100644
--- i/src/backend/libpq/auth.c
+++ w/src/backend/libpq/auth.c
@@ -442,33 +442,61 @@ ClientAuthentication(Port *port)
 				if (am_walsender)
 				{
 #ifdef USE_SSL
-					ereport(FATAL,
-					   (errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
-						errmsg("no pg_hba.conf entry for replication connection from host \"%s\", user \"%s\", %s",
-							   hostinfo, port->user_name,
-							   port->ssl ? _("SSL on") : _("SSL off"))));
+					if (port->remote_hostname_resolv == +1)
+						ereport(FATAL,
+								(errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
+								 errmsg("no pg_hba.conf entry for replication connection from host \"%s\" (%s), user \"%s\", %s",
+										port->remote_hostname, hostinfo, port->user_name,
+										port->ssl ? _("SSL on") : _("SSL off"))));
+					else
+						ereport(FATAL,
+								(errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
+								 errmsg("no pg_hba.conf entry for replication connection from host \"%s\", user \"%s\", %s",
+										hostinfo, port->user_name,
+										port->ssl ? _("SSL on") : _("SSL off"))));
 #else
-					ereport(FATAL,
-					   (errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
-						errmsg("no pg_hba.conf entry for replication connection from host \"%s\", user \"%s\"",
-							   hostinfo, port->user_name)));
+					if (port->remote_hostname_resolv == +1)
+						ereport(FATAL,
+								(errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
+								 errmsg("no pg_hba.conf entry for replication connection from host \"%s\" (%s), user \"%s\"",
+										port->remote_hostname, hostinfo, port->user_name)));
+					else
+						ereport(FATAL,
+								(errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
+								 errmsg("no pg_hba.conf entry for replication connection from host \"%s\", user \"%s\"",
+										hostinfo, port->user_name)));
 #endif
 				}
 				else
 				{
 #ifdef USE_SSL
-					ereport(FATAL,
-					   (errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
-						errmsg("no pg_hba.conf entry for host \"%s\", user \"%s\", database \"%s\", %s",
-							   hostinfo, port->user_name,
-							   port->database_name,
-							   port->ssl ? _("SSL on") : _("SSL off"))));
+					if (port->remote_hostname_resolv == +1)
+						ereport(FATAL,
+								(errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
+								 errmsg("no pg_hba.conf entry for host \"%s\" (%s), user \"%s\", database \"%s\", %s",
+										port->remote_hostname, hostinfo, port->user_name,
+										port->database_name,
+										port->ssl ? _("SSL on") : _("SSL off"))));
+					else
+						ereport(FATAL,
+								(errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
+								 errmsg("no pg_hba.conf entry for host \"%s\", user \"%s\", database \"%s\", %s",
+										hostinfo, port->user_name,
+										port->database_name,
+										port->ssl ? _("SSL on") : _("SSL off"))));
 #else
-					ereport(FATAL,
-					   (errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
-						errmsg("no pg_hba.conf entry for host \"%s\", user \"%s\", database \"%s\"",
-							   hostinfo, port->user_name,
-							   port->database_name)));
+					if (port->remote_hostname_resolv == +1)
+						ereport(FATAL,
+								(errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
+								 errmsg("no pg_hba.conf entry for host \"%s\" (%s), user \"%s\", database \"%s\"",
+										port->remote_hostname, hostinfo, port->user_name,
+										port->database_name)));
+					else
+						ereport(FATAL,
+								(errcode(ERRCODE_INVALID_AUTHORIZATION_SPECIFICATION),
+								 errmsg("no pg_hba.conf entry for host \"%s\", user \"%s\", database \"%s\"",
+										hostinfo, port->user_name,
+										port->database_name)));
 #endif
 				}
 				break;
